import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;
 
 
public class BalanceCanvas extends RGBCanvas {
  

   BalanceCanvas(String name) {
     try {	 
    		image = ImageIO.read(new File(name));
		  w=image.getWidth(null);  h=image.getHeight(null);
		R= new BufferedImage(w,h,R. TYPE_INT_RGB );
		G= new BufferedImage(w,h,R. TYPE_INT_RGB );
		B= new BufferedImage(w,h,R. TYPE_INT_RGB );
		for(int x=0;x<w;x++)
		for(int y=0;y<h;y++)
		{
			/* Format of a pixel 
			Number of bits:        32
 			Red mask:              0x00ff0000
 			Green mask:            0x0000ff00
 			Blue mask:             0x000000ff
			*/
			int r,g,b;
			r=((image.getRGB(x,y) & 0x00ff0000)>>16);
			g=(image.getRGB(x,y) & 0x0000ff00)>>8;
			b=image.getRGB(x,y) & 0x000000ff;
			r= 60+ r/2;
			b= 60+ b/2;
			g= 60+ g/2; 
			R.setRGB(x,y,r=r<<16 );
			G.setRGB(x,y,g=g<<8);
			B.setRGB(x,y,b);
			image.setRGB(x,y,r+g+b);
		}
	} catch (IOException e) {
		System.err.println(e.toString()+" can not open "+name);
	}		

    }
    
 

   public static void main(String argv[])throws InterruptedException {
    if (argv.length < 1) {
       System.out.println
          ("usage: BalanceCanvas.class [image file name]");
       System.exit(0);
       }
    Frame frame = new Frame(argv[0]);
    frame.setLayout(new BorderLayout());
    frame.add("Center", new BalanceCanvas(argv[0]));
     frame.pack();
    frame.setVisible(true);
    Thread.sleep(10000);
	System.exit(0);

    }

   }
