import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;
 
 
public class CellCanvas extends ImageCanvas {
   static final int len = 128;
   static final int cellsize = 7;
   int [] current = new int[len];
   int [] previous = new int [len];
   int w=len*cellsize;
   int h=len*cellsize;
   public Dimension getPreferredSize() {
        if (image == null) {
             return new Dimension(300,300);
        } else {
           return new Dimension(w+10,  h+10 );
       }
    }

   int old(int x){ return previous[x &(len-1)];}
   CellCanvas(int[] rule) {
     	        current[len >>1]=current[len-1]=current[0]=1;
    		image =  new BufferedImage(w,h,BufferedImage. TYPE_INT_RGB );
		for(int i=0;i<len;i++) 
                {
	          //swap the rows
                  {int [] temp = previous; previous=current; current=temp;}
		  for(int j=0;j<len;j++)
		  {
		      current[j]=rule[old(j-1)+old(j)+old(j+1)] &3;
                      int colour = 0x00ff0000 >> (6*current[j]);
		      for(int x=0;x<cellsize;x++) 
                        
			for(int y=0;y<cellsize;y++)
			 
			/* Format of a pixel 
			Number of bits:        32
 			Red mask:              0x00ff0000
 			Green mask:            0x0000ff00
 			Blue mask:             0x000000ff
			*/
			 
			image.setRGB( x+i*cellsize, y+j*cellsize,colour);
		         
                      
                 }
               }
	 		

    }
    
 

   public static void main(String argv[])throws InterruptedException {
     int [] rule = {0,3,0,1,0,1,0,1,0,1};
    Frame frame = new Frame( "Cellular Automaton");
    frame.setLayout(new BorderLayout());
    frame.add("Center", new CellCanvas( rule));
     frame.pack();
    frame.setVisible(true);
    Thread.sleep(10000);
	System.exit(0);

    }

   }
